# -*- coding: utf-8 -*-
from setuphelpers import *
import time

uninstallkey = []

def install():

    softname = 'GeoGebra'
    versionsoft = control['version'].split('-',1)[0]
    fileversion = versionsoft.replace('.','-')

    check_installed = installed_softwares(softname)
    if check_installed:
             for uninstall in check_installed:
                         print(u'remove old software')
                         killalltasks("javaw.exe")
                         cmd = WAPT.uninstall_cmd(uninstall['key'])
                         run(cmd)
                         time.sleep(5)

    WAPT.options.force = True


    for msi in glob.glob(makepath(programfiles32,'GeoGebra Classic','*.msi')):
        remove_file(msi)
    if not isdir(makepath(programfiles32,'GeoGebra Classic')):
        mkdirs(makepath(programfiles32,'GeoGebra Classic'))
    filecopyto('GeoGebra-Windows-Installer-%s.msi' % fileversion,makepath(programfiles32,'GeoGebra Classic','GeoGebra-Windows-Installer-%s.msi' % fileversion))
    install_msi_if_needed(makepath(programfiles32,'GeoGebra Classic','GeoGebra-Windows-Installer-%s.msi' % fileversion),killbefore=['javaw.exe'], properties={'ALLUSERS':2})
    remove_desktop_shortcut('GeoGebra')




def update_package():


    masterversion = '6.0'
    """I retrieve the current version from the official site >>>"""
    versionfile = ensure_unicode(wgets("https://download.geogebra.org/installers/%s/version.txt" % masterversion))
    realversion = versionfile.replace('-','.')
    print('Latest Version : ' + realversion)

    """I write the version in the control file >>>"""

    control.version = realversion + '-0'
    control.save_control_to_wapt()

    """
    I list all the msi file of the package and test the msi version
    if the version returned by the msi does not correspond to the previous one, I delete the file
    >>>
    """

    allmsi = glob.glob('*.msi')
    for msi in allmsi:
            vers = get_msi_properties(msi)['ProductVersion']
            if  vers != realversion :
                remove_file(msi)

    """I download the file if it does not exist >>>"""
    if not isfile('GeoGebra-Windows-Installer-%s.msi' % versionfile) :
        wget('https://download.geogebra.org/installers/%s/GeoGebra-Windows-Installer-%s.msi' % (masterversion,versionfile),os.getcwd())

    print('The update is complete, you can now test and then launch a build upload.')



def uninstall():
    for msi in glob.glob(makepath(programfiles32,'GeoGebra Classic','*.msi')):
        remove_file(msi)